%define __noautoreq devel\\(libtcl

%define Werror_cflags %nil
%define _disable_ld_no_undefined 1

%define pgdata /var/lib/pgsql
%define logrotatedir %{_sysconfdir}/logrotate.d

%define major 5
%define major_ecpg 6

%define bname postgresql
%define current_major_version 9.0
%define current_minor_version 16

%define libname %mklibname pq%{current_major_version} _%{major}
%define libecpg %mklibname ecpg%{current_major_version} _%{major_ecpg}

%bcond_without uuid

Summary:	PostgreSQL client programs and libraries
Name:		%{bname}%{current_major_version}
Version:	%{current_major_version}.%{current_minor_version}
Release:	1
License:	BSD
Group:		Databases
Url:		http://www.postgresql.org/
Source0:	ftp://ftp.postgresql.org/pub/source/v%{version}/postgresql-%{version}.tar.bz2
Source5:	ftp://ftp.postgresql.org/pub/source/v%{version}/postgresql-%{version}.tar.bz2.md5
Source10:	postgres.profile
Source11:	postgresql.init
Source13:	postgresql.mdv.releasenote
Patch0:		postgresql-9.0.4_ossp-uuid-dir.patch
Patch1:		postgresql-9.0.8-soname_fix.diff
# Need to build doc
BuildRequires:	docbook-dtd42-sgml
BuildRequires:	docbook-dtd44-xml
BuildRequires:	docbook-style-xsl
BuildRequires:	docbook-utils
BuildRequires:	openjade
BuildRequires:	xsltproc
# Main deps
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	pam-devel
BuildRequires:	perl-devel
BuildRequires:	readline-devel
BuildRequires:	tcl-devel
BuildRequires:	pkgconfig(libxml-2.0)
BuildRequires:	pkgconfig(libxslt)
BuildRequires:	pkgconfig(openssl)
%if %{with uuid}
BuildRequires:	pkgconfig(ossp-uuid)
%endif
BuildRequires:	pkgconfig(python)
BuildRequires:	pkgconfig(zlib)
Provides:	%{bname}-virtual = %{current_major_version}
Conflicts:	%{bname}-virtual < %{current_major_version}
Requires:	%{libname} = %{EVRD}
Provides:	%{bname} = %{EVRD}
Provides:	postgresql-clients = %{EVRD}

%description
PostgreSQL is an advanced Object-Relational database management system (DBMS)
that supports almost all SQL constructs (including transactions, subselects and
user-defined types and functions). The postgresql package includes the client
programs and libraries that you'll need to access a PostgreSQL DBMS server.
These PostgreSQL client programs are programs that directly manipulate the
internal structure of PostgreSQL databases on a PostgreSQL server. These client
programs can be located on the same machine with the PostgreSQL server, or may
be on a remote machine which accesses a PostgreSQL server over a network
connection. This package contains the client libraries for C and C++, as well
as command-line utilities for managing PostgreSQL databases on a PostgreSQL
server.

If you want to manipulate a PostgreSQL database on a remote PostgreSQL server,
you need this package. You also need to install this package if you're
installing the postgresql-server package.

%files -f main.lst
%doc doc/KNOWN_BUGS doc/MISSING_FEATURES doc/README* 
%doc COPYRIGHT README HISTORY doc/bug.template
%{_bindir}/clusterdb
%{_bindir}/createdb
%{_bindir}/createlang
%{_bindir}/createuser
%{_bindir}/dropdb
%{_bindir}/droplang
%{_bindir}/dropuser
%{_bindir}/pg_dump
%{_bindir}/pg_dumpall
%{_bindir}/pg_restore
%{_bindir}/psql
%{_bindir}/reindexdb
%{_bindir}/vacuumdb
%{_mandir}/man1/clusterdb.*
%{_mandir}/man1/createdb.*
%{_mandir}/man1/createlang.*
%{_mandir}/man1/createuser.*
%{_mandir}/man1/dropdb.*
%{_mandir}/man1/droplang.*
%{_mandir}/man1/dropuser.*
%{_mandir}/man1/pg_dump.*
%{_mandir}/man1/pg_dumpall.*
%{_mandir}/man1/pg_restore.*
%{_mandir}/man1/psql.*
%{_mandir}/man1/vacuumdb.*
%{_mandir}/man1/reindexdb.*
%{_mandir}/man7/*
%{_sys_macros_dir}/%{name}.macros

#----------------------------------------------------------------------------

%package -n %{libname}
Summary:	The shared libraries required for any PostgreSQL clients
Group:		System/Libraries
Provides:	postgresql-libs = %{EVRD}
Provides:	libpq = %{EVRD}
Provides:	%{_lib}pq-virtual = %{current_major_version}
Conflicts:	postgresql-libs < %{current_major_version}

%description -n %{libname}
C and C++ libraries to enable user programs to communicate with the PostgreSQL
database backend. The backend can be on another machine and accessed through
TCP/IP.

%files -n %{libname}
%{_libdir}/libpq.so.%{major}*

#----------------------------------------------------------------------------

%package -n %{libecpg}
Summary:	Shared library libecpg for PostgreSQL
Group:		System/Libraries
Provides:	libecpg = %{EVRD}
Provides:	%{_lib}ecpg-virtual = %{current_major_version}
Conflicts:	libecpg < %{current_major_version}

%description -n %{libecpg}
Libecpg is used by programs built with ecpg (Embedded PostgreSQL for C) Use
postgresql-dev to develop such programs.

%files -n %{libecpg}
%{_libdir}/libecpg.so.%{major_ecpg}*
%{_libdir}/libecpg_compat.so.*
%{_libdir}/libpgtypes.so.*

#----------------------------------------------------------------------------

%package server
Summary:	The programs needed to create and run a PostgreSQL server
Group:		Databases
Provides:	sqlserver
# add/remove services
Requires(post,preun):	rpm-helper
# add/del user
Requires(pre,postun):	rpm-helper
Requires(pre,post):	%{name} = %{EVRD}
Provides:	%{bname}-server-ABI = %{current_major_version}
Provides:	%{bname}-server-virtual = %{current_major_version}
Conflicts:	%{bname}-server-virtual < %{current_major_version}
Provides:	%{bname}-server = %{EVRD}
Requires:	%{name}-plpgsql = %{EVRD}

%description server
The postgresql-server package includes the programs needed to create and run a
PostgreSQL server, which will in turn allow you to create and maintain
PostgreSQL databases.  PostgreSQL is an advanced Object-Relational database
management system (DBMS) that supports almost all SQL constructs (including
transactions, subselects and user-defined types and functions). You should
install postgresql-server if you want to create and maintain your own
PostgreSQL databases and/or your own PostgreSQL server. You also need to
install the postgresql and postgresql-devel packages.

After installing this package, please read postgresql.mdv.releasenote.

%files server -f server.lst
%{_initrddir}/postgresql
%config(noreplace) %{_sysconfdir}/sysconfig/postgresql
%doc README.urpmi postgresql.mdv.releasenote
%{_bindir}/initdb
%{_bindir}/pg_controldata
%{_bindir}/pg_ctl
%{_bindir}/pg_resetxlog
%{_bindir}/postgres
%{_bindir}/postmaster
%{_bindir}/pg_standby
%{_bindir}/pg_archivecleanup
%{_bindir}/pg_upgrade
%{_mandir}/man1/initdb.1*
%{_mandir}/man1/pg_controldata.*
%{_mandir}/man1/pg_ctl.1*
%{_mandir}/man1/pg_resetxlog.*
%{_mandir}/man1/postgres.1*
%{_mandir}/man1/postmaster.1*
%dir %{_libdir}/postgresql
%dir %{_datadir}/postgresql
%attr(644,postgres,postgres) %config(noreplace) /var/lib/pgsql/.bashrc
%attr(-,postgres,postgres) /var/lib/pgsql/.profile
%attr(700,postgres,postgres) %dir %{pgdata}
%attr(-,postgres,postgres) %{pgdata}/data
%attr(700,postgres,postgres) %dir %{pgdata}/backups
%{_libdir}/postgresql/*_and_*.so
%{_libdir}/postgresql/pgxml.so
%{_libdir}/postgresql/dict_int.so
%{_libdir}/postgresql/dict_xsyn.so
%{_libdir}/postgresql/test_parser.so
%{_libdir}/postgresql/tsearch2.so
%{_libdir}/postgresql/dict_snowball.so
%{_libdir}/postgresql/auto_explain.so
%{_libdir}/postgresql/btree_gin.so
%{_libdir}/postgresql/citext.so
%{_libdir}/postgresql/pg_stat_statements.so
%if %{with uuid}
%{_libdir}/postgresql/uuid-ossp.so
%endif
%{_libdir}/postgresql/euc2004_sjis2004.so
%{_libdir}/postgresql/libpqwalreceiver.so
%{_libdir}/postgresql/passwordcheck.so
%{_libdir}/postgresql/pg_upgrade_support.so
%{_libdir}/postgresql/unaccent.so
%{_datadir}/postgresql/postgres.bki
%{_datadir}/postgresql/postgres.description
%{_datadir}/postgresql/*.sample
%{_datadir}/postgresql/timezone
%{_datadir}/postgresql/system_views.sql
%{_datadir}/postgresql/conversion_create.sql
%{_datadir}/postgresql/information_schema.sql
%{_datadir}/postgresql/snowball_create.sql
%{_datadir}/postgresql/sql_features.txt
%{_datadir}/postgresql/postgres.shdescription
%dir %{_datadir}/postgresql/timezonesets
%{_datadir}/postgresql/timezonesets/Africa.txt
%{_datadir}/postgresql/timezonesets/America.txt
%{_datadir}/postgresql/timezonesets/Antarctica.txt
%{_datadir}/postgresql/timezonesets/Asia.txt
%{_datadir}/postgresql/timezonesets/Atlantic.txt
%{_datadir}/postgresql/timezonesets/Australia
%{_datadir}/postgresql/timezonesets/Australia.txt
%{_datadir}/postgresql/timezonesets/Default
%{_datadir}/postgresql/timezonesets/Etc.txt
%{_datadir}/postgresql/timezonesets/Europe.txt
%{_datadir}/postgresql/timezonesets/India
%{_datadir}/postgresql/timezonesets/Indian.txt
%{_datadir}/postgresql/timezonesets/Pacific.txt
%{_datadir}/postgresql/tsearch_data
%attr(700,postgres,postgres) %dir /var/log/postgres
%{logrotatedir}/%{bname}

%pre server
%_pre_useradd postgres /var/lib/pgsql /bin/bash

[ ! -f %{pgdata}/data/PG_VERSION ] && exit 0
mypgversion=`cat %{pgdata}/data/PG_VERSION`
[ $mypgversion = %{current_major_version} ] && exit 0

echo ""
echo "You currently have database tree for Postgresql $mypgversion"
echo "You must use postgresql${mypgversion}-server"
echo "To update you Postgresql server, dump your databases"
echo "delete /var/lib/pgsql/data/ content, upgrade the server, then"
echo "restore your databases from your backup"
echo ""

exit 1

%posttrans server

%_post_service %{bname}

%preun server
%_preun_service %{bname}

%postun server
%_postun_userdel postgres

#----------------------------------------------------------------------------

%package docs
Summary:	Extra documentation for PostgreSQL
Group:		Documentation
Provides:	%{bname}-docs-virtual = %{current_major_version}
Conflicts:	%{bname}-docs-virtual < %{current_major_version}

%description docs
The postgresql-docs package includes the SGML source for the documentation as
well as the documentation in other formats, and some extra documentation.
Install this package if you want to help with the PostgreSQL documentation
project, or if you want to generate printed documentation.

%files docs
%doc %{_docdir}/%{name}-docs-%{version}

#----------------------------------------------------------------------------

%package contrib
Summary:	Contributed binaries distributed with PostgreSQL
Group:		Databases
Requires:	%{name}-server = %{EVRD}
Provides:	%{bname}-contrib-virtual = %{current_major_version}
Conflicts:	%{bname}-contrib-virtual < %{current_major_version}

%description contrib
The postgresql-contrib package includes the contrib tree distributed with the
PostgreSQL tarball.  Selected contrib modules are prebuilt.

%files contrib
%{_libdir}/postgresql/_int.so
%{_libdir}/postgresql/btree_gist.so
%{_libdir}/postgresql/chkpass.so
%{_libdir}/postgresql/cube.so
%{_libdir}/postgresql/dblink.so
%{_libdir}/postgresql/earthdistance.so
%{_libdir}/postgresql/fuzzystrmatch.so
%{_libdir}/postgresql/insert_username.so
%{_libdir}/postgresql/lo.so
%{_libdir}/postgresql/ltree.so
%{_libdir}/postgresql/moddatetime.so
%{_libdir}/postgresql/pgcrypto.so
%{_libdir}/postgresql/pgstattuple.so
%{_libdir}/postgresql/refint.so
%{_libdir}/postgresql/seg.so
%{_libdir}/postgresql/tablefunc.so
%{_libdir}/postgresql/timetravel.so
%{_libdir}/postgresql/pg_trgm.so
%{_libdir}/postgresql/autoinc.so
%{_libdir}/postgresql/pg_buffercache.so
%{_libdir}/postgresql/adminpack.so
%{_libdir}/postgresql/hstore.so
%{_libdir}/postgresql/isn.so
%{_libdir}/postgresql/pg_freespacemap.so
%{_libdir}/postgresql/pgrowlocks.so
%{_libdir}/postgresql/sslinfo.so
%{_libdir}/postgresql/pageinspect.so
%{_datadir}/postgresql/contrib/
%{_bindir}/oid2name
%{_bindir}/pgbench
%{_bindir}/vacuumlo

#----------------------------------------------------------------------------

%package devel
Summary:	PostgreSQL development header files and libraries
Group:		Development/Databases
Provides:	%{bname}-devel-virtual = %{current_major_version}
Conflicts:	%{bname}-devel-virtual < %{current_major_version}
Requires:	%{name} = %{EVRD}
Requires:	%{libname} = %{EVRD}
Requires:	%{libecpg} = %{EVRD}
Provides:	postgresql-libs-devel = %{EVRD}
Provides:	pq-devel = %{EVRD}
Provides:	libpq-devel = %{EVRD}
Provides:	libecpg-devel = %{EVRD}
Provides:	%{bname}-devel = %{EVRD}

%description devel
The postgresql-devel package contains the header files and libraries needed to
compile C or C++ applications which will directly interact with a PostgreSQL
database management server and the ecpg Embedded C Postgres preprocessor. You
need to install this package if you want to develop applications which will
interact with a PostgreSQL server. If you're installing postgresql-server, you
need to install this package.

%files devel
%{_includedir}/*
%{_bindir}/ecpg
%{_libdir}/lib*.a
%{_libdir}/lib*.so
%{_libdir}/postgresql/pgxs/
%{_mandir}/man1/ecpg.1*
%{_bindir}/pg_config
%{_mandir}/man1/pg_config.1*
%{_mandir}/man3/SPI_*.3*
%{_mandir}/man3/dblink*.3*

#----------------------------------------------------------------------------

%package pl
Summary:	Procedurals languages for PostgreSQL
Group:		Databases
Conflicts:	libpgsql2
Requires:	%{name}-plpython = %{EVRD}
Requires:	%{name}-plperl = %{EVRD}
Requires:	%{name}-pltcl = %{EVRD}
Requires:	%{name}-plpgsql = %{EVRD}
Provides:	%{bname}-pl-virtual = %{current_major_version}
Conflicts:	%{bname}-pl-virtual < %{current_major_version}
Provides:	%{bname}-pl = %{EVRD}

%description pl
PostgreSQL is an advanced Object-Relational database management system. The
postgresql-pl will install the the PL/Perl, PL/Tcl, and PL/Python procedural
languages for the backend. PL/Pgsql is part of the core server package.

%files pl

#----------------------------------------------------------------------------

%package plpython
Summary:	The PL/Python procedural language for PostgreSQL
Group:		Databases
Requires:	%{name}-server = %{EVRD}
Requires:	%{bname}-server-ABI = %{current_major_version}
Provides:	%{bname}-plpython-virtual = %{current_major_version}
Conflicts:	%{bname}-plpython-virtual < %{current_major_version}
Provides:	%{bname}-plpython = %{EVRD}

%description plpython
PostgreSQL is an advanced Object-Relational database management system. The
postgresql-plpython package contains the the PL/Python procedural languages for
the backend. PL/Python is part of the core server package.

%files plpython
%{_libdir}/postgresql/plpython.so
%{_libdir}/postgresql/plpython2.so

#----------------------------------------------------------------------------

%package plperl
Summary:	The PL/Perl procedural language for PostgreSQL
Group:		Databases
Requires:	%{name}-server = %{EVRD}
Requires:	%{bname}-server-ABI = %{current_major_version}
Provides:	%{bname}-plperl-virtual = %{current_major_version}
Conflicts:	%{bname}-plperl-virtual < %{current_major_version}
Provides:	%{bname}-plperl = %{EVRD}

%description plperl
PostgreSQL is an advanced Object-Relational database management system. The
postgresql-plperl package contains the the PL/Perl procedural languages for the
backend. PL/Perl is part of the core server package.

%files plperl
%{_libdir}/postgresql/plperl.so

#----------------------------------------------------------------------------

%package pltcl
Summary:	The PL/Tcl procedural language for PostgreSQL
Group:		Databases
Requires:	%{name}-server = %{EVRD}
Requires:	%{bname}-server-ABI = %{current_major_version}
Provides:	%{bname}-pltcl-virtual = %{current_major_version}
Conflicts:	%{bname}-pltcl-virtual < %{current_major_version}
Provides:	%{bname}-pltcl = %{EVRD}

%description pltcl
PostgreSQL is an advanced Object-Relational database management system. The
postgresql-pltcl package contains the the PL/Tcl procedural languages for the
backend. PL/Tcl is part of the core server package.

%files pltcl
%{_libdir}/postgresql/pltcl.so
%{_bindir}/pltcl_delmod
%{_bindir}/pltcl_listmod
%{_bindir}/pltcl_loadmod
%{_datadir}/postgresql/unknown.pltcl

#----------------------------------------------------------------------------

%package plpgsql
Summary:	The PL/PgSQL procedural language for PostgreSQL
Group:		Databases
Requires:	%{name}-server = %{EVRD}
Requires:	%{bname}-server-ABI = %{current_major_version}
Provides:	%{bname}-plpgsql-virtual = %{current_major_version}
Conflicts:	%{bname}-plpgsql-virtual < %{current_major_version}
Provides:	%{bname}-plpgsql = %{EVRD}

%description plpgsql
PostgreSQL is an advanced Object-Relational database management system. The
postgresql-plpgsql package contains the the PL/PgSQL procedural languages for
the backend. PL/PgSQL is part of the core server package.

%files plpgsql
%{_libdir}/postgresql/plpgsql.so

#----------------------------------------------------------------------------

%prep
%setup -q -n %{bname}-%{version}
%patch0 -p1 -b .ossp-uuid_dir~
%patch1 -p1 -b .soname_fix

%build
%serverbuild
# it does not work with -fPIE and someone added that to the serverbuild macro...
CFLAGS=`echo $CFLAGS|sed -e 's|-fPIE||g'`
CXXFLAGS=`echo $CXXFLAGS|sed -e 's|-fPIE||g'`

%configure2_5x \
	--disable-rpath \
	--with-perl \
	--with-python \
	--with-tcl \
	--with-tclconfig=%{_libdir} \
	--with-openssl \
	--with-pam \
	--with-libxml \
	--with-libxslt \
	--libdir=%{_libdir} \
	--mandir=%{_mandir} \
	--prefix=%{_prefix} \
	--sysconfdir=%{_sysconfdir}/pgsql \
	--enable-nls \
%if %{with uuid}
	--with-ossp-uuid
%endif

# nuke -Wl,--no-undefined
perl -pi -e "s|-Wl,--no-undefined||g" src/Makefile.global

%if %{with uuid}
# bork...
echo "#define HAVE_OSSP_UUID_H 1" >> src/include/pg_config.h
%endif

%make world

pushd src/test
make all
popd


%install
make DESTDIR=%{buildroot} install-world install-docs

# install odbcinst.ini
mkdir -p %{buildroot}%{_sysconfdir}/pgsql

# PGDATA needs removal of group and world permissions due to pg_pwd hole.
install -d -m 700 %{buildroot}/var/lib/pgsql/data

# backups of data go here...
install -d -m 700 %{buildroot}/var/lib/pgsql/backups

# Create the multiple postmaster startup directory
install -d -m 700 %{buildroot}/etc/sysconfig/pgsql

mkdir -p %{buildroot}%{_var}/log/postgres

mkdir -p %{buildroot}%{logrotatedir}
cat > %{buildroot}%{logrotatedir}/%{bname} <<EOF
/var/log/postgres/postgresql {
    notifempty
    missingok
    copytruncate
}
EOF

install -D -m755 %{SOURCE11} %{buildroot}%{_initrddir}/postgresql

mv %{buildroot}%{_docdir}/%{bname}/html %{buildroot}%{_docdir}/%{name}-docs-%{version}

echo -n '' > main.lst
for i in \
    pg_ctl initdb pg_config psql pg_dump pgscripts \
    ecpg libpq%{major} ecpglib%{major_ecpg}; do
    %find_lang $i-%{current_major_version}
    cat $i-%{current_major_version}.lang >> main.lst
#    %find_lang $i
#    cat $i.lang >> main.lst
done
echo -n '' > server.lst
for i in postgres pg_resetxlog pg_controldata plpgsql plpython plperl pltcl; do
#    %find_lang $i
#    cat $i.lang >> server.lst
    %find_lang $i-%{current_major_version}
    cat $i-%{current_major_version}.lang >> server.lst
done

# pg_ctl.lang initdb.lang pg_config.lang psql.lang pg_dump.lang pgscripts.lang \
# postgres.lang pg_resetxlog.lang pg_controldata.lang \
# libpq.lang libecpg.lang \

# taken directly in build dir.
rm -fr %{buildroot}%{_datadir}/doc/postgresql/contrib/

#(
#cd postgresql-mdk
#make install DESTDIR=%buildroot
#)

mkdir -p %{buildroot}%{_sys_macros_dir}
cat > %{buildroot}%{_sys_macros_dir}/%{name}.macros <<EOF
%%postgresql_version %{version}
%%postgresql_major   %{current_major_version}
%%postgresql_minor   %{current_minor_version}
%%pgmodules_req Requires:	%{bname}-server-ABI} = %{current_major_version}
EOF

cat %{SOURCE13} > postgresql.mdv.releasenote
cat > README.urpmi <<EOF
You just installed or updated %{bname} server.
You can find important information about mandriva %{bname} rpms and database
management in:

%{_defaultdocdir}/%{name}-server/postgresql.mdv.releasenote

Please read it.
EOF

# postgres' .profile and .bashrc
install -D -m 700 %{SOURCE10} %{buildroot}%{_var}/lib/pgsql/.profile
(
cd %{buildroot}%{_var}/lib/pgsql/
ln -s .profile .bashrc
)

cat > %{buildroot}%{_sysconfdir}/sysconfig/postgresql <<EOF
# Olivier Thauvin <nanardon@mandriva.org>

# The database location:
# You probably won't change this
# PGDATA=/var/lib/pgsql/data

# What is the based locales for postgresql
# Setting locales to C allow to use any encoding
# ISO or UTF, any other choice will restrict you
# either ISO or UTF.
LC_ALL=C

# These are additional to pass to pg_ctl when starting/restarting postgresql.
# PGOPTIONS=
EOF

%check
make check


%changelog
* Wed Jul 09 2014 Andrey Bondrov <andrey.bondrov@rosalab.ru> 9.0.16-1
+ Revision: 9e76c81
- Spec cleanup


